2006-06-01  Alexander Chernov  <cher@ispras.ru>

	* message.c: copyright notice is updated;
	(serve_clnt_message) `hide_flag' parameter is added and then
	  passed to the server.

2006-04-19  Alexander Chernov  <cher@ispras.ru>

	* show_item.c: copyright notice is updated;
	(serve_clnt_show_item) check for a correct command code is commeted
	  out.

2006-02-13  Alexander Chernov  <cher@ispras.ru>

	* rejudge_by_mask.c: copyright notice is updated;
	(serve_clnt_rejudge_by_mask) check for valid value of `cmd'
	  is removed.

2005-12-02  Alexander Chernov  <cher@ispras.ru>

	* submit_run_2.c: initial revision

2005-11-25  Alexander Chernov  <cher@ispras.ru>

	* send_packet.c, show_item.c, standings.c, submit_clar.c, submit_run.c, team_page.c, upload_report.c, view.c, do_pass_fd.c, edit_run.c, edit_user.c, get_archive.c, get_param.c, import_xml_runs.c, master_page.c, message.c, open.c, recv_packet.c, rejudge_by_mask.c, reset_filter.c:
	Copyright notice is updated.
	"errlog.h" is included instead of "pathutl.h".

2005-11-03  Alexander Chernov  <cher@ispras.ru>

	* edit_run.c:
	(do_serve_clnt_edit_run) `ej_ip_t' type is used for `ip';
	  `ssl' parameter is added and passed to the server;
	(serve_clnt_edit_run) call of `do_serve_clnt_edit_run' is updated;
	(serve_clnt_new_run) `ej_ip_t' type is used for `ip';
	  `ssl' parameter is added and passed to `do_serve_clnt_edit_run'.

	* master_page.c:
	(serve_clnt_master_page) `ej_cookie_t' type is used for `session_id';
	  `ej_ip_t' type is used for `ip';
	  `ssl' parameter is added and passed to the server.

	* reset_filter.c:
	(serve_clnt_reset_filter) `ej_cookie_t' type is used for `session_id'.

	* submit_clar.c: 
	(serve_clnt_submit_clar) `ej_ip_t' is used for `ip';
	  `ssl' parameter is added and passed to the server.

	* submit_run.c: 
	(serve_clnt_submit_run) `ej_ip_t' is used for `ip';
	  `ssl' parameter is added and passed to the server.

	* send_packet.c: (serve_clnt_send_packet) bugfixes.

2005-11-03  Alexander Chernov  <cher@ispras.ru>

	* send_packet.c: copyright notice is updated;
	<reuse/integral.h> is included;
	<sys/uio.h> is included;
	(serve_clnt_send_packet) `size' parameter now has type `size_t';
	  the function is rewritten to avoid copying of sending data
	  into a temporary buffer.

	* edit_run.c: copyright notice is updated;
	(do_serve_clnt_edit_run) fixes for 64-bit platforms.

	* edit_user.c: copyright notice is updated;
	(serve_clnt_edit_user) fixes for 64-bit platforms.

	* get_archive.c: copyright notice is updated;
	(serve_clnt_get_archive) fixes for 64-bit platforms.

	* open.c: copyright notice is updated;
	(serve_clnt_open) fixes for 64-bit platforms.

	* recv_packet.c: copyright notice is updated;
	(serve_clnt_recv_packet) fixes for 64-bit platforms.

	* rejudge_by_mask.c: copyright notice is updated;
	(serve_clnt_rejudge_by_mask) "const" qualifier added to `mask'
	  parameter;
	  fixes for 64-bit platforms.

	* reset_filter.c:
	(serve_clnt_reset_filter) fixes for 64-bit platforms.

	* show_item.c: copyright notice is updated;
	(serve_clnt_show_item) fixes for 64-bit platforms.

	* submit_clar.c: copyright notice is updated;
	(serve_clnt_submit_clar) fixes for 64-bit platforms.

	* submit_run.c: copyright notice is updated;
	(serve_clnt_submit_run) fixes for 64-bit platforms.

	* upload_report.c: copyright notice is updated;
	(serve_clnt_upload_report) fixes for 64-bit platforms.

2005-07-28  Alexander Chernov  <cher@ispras.ru>

	* get_param.c: initial revision

2005-05-02  Alexander Chernov  <cher@ispras.ru>

	* master_page.c:
	(serve_clnt_master_page) `sid_mode' parameter is removed since the
	  corresponding packet field is removed.

	* standings.c: copyright notice is updated;
	(serve_clnt_standings) `sid_mode' parameter is removed since the
	  corresponding packet field is removed.

	* team_page.c: copyright notice is updated;
	(serve_clnt_team_page) `sid_mode' parameter is removed since the
	  corresponding packet field is removed.

	* view.c:
	(serve_clnt_view) `sid_mode' parameter is removed, since the
	  corresponding field is removed.

2005-04-28  Alexander Chernov  <cher@ispras.ru>

	* view.c: copyright notice is updated;
	(serve_clnt_view) remove check for valid command code.

2005-01-15  Alexander Chernov  <cher@ispras.ru>

	* simple_cmd.c: copyright notice is updated;
	(serve_clnt_simple_cmd) any positive return value from the server is
	  accepted and returned from the function since this value may contain
	  some information for the caller. In the previous version only
	  SRV_RPL_OK (0) was allowed as a server's reply.

	* master_page.c: copyright notice is updated;
	(serve_clnt_master_page) added new parameter `mode_clar', which is
	  then passed to the server.

	* reset_filter.c: copyright notice is updated;
	(serve_clnt_reset_filter) removed redundant check for valid `cmd'
	  parameter.

2004-12-20  Alexander Chernov  <cher@ispras.ru>

	* master_page.c:
	(serve_clnt_master_page) `cmd' parameter is added, which is a
	  command instead of the fixed `SRV_CMD_MASTER_PAGE'.

	* edit_run.c:
	(do_serve_clnt_edit_run) `score_adj' parameter is added, which is
	  further passed to the server;
	(serve_clnt_edit_run) `score_adj' parameter is added, which is passed
	  to the function above.

2004-11-09  Alexander Chernov  <cher@ispras.ru>

	* import_xml_runs.c:
	(serve_clnt_import_xml_runs) parameter `flags' is added, which is
	  passed to the server.

2004-10-31  Alexander Chernov  <cher@ispras.ru>

	* view.c: (serve_clnt_view) SRV_CMD_VIEW_TEAM command is supported.

	* edit_user.c: initial revision

2004-10-25  Alexander Chernov  <cher@ispras.ru>

	* rejudge_by_mask.c:
	(serve_clnt_rejudge_by_mask) a stupid bug is fixed.

2004-09-27  Alexander Chernov  <cher@ispras.ru>

	* edit_run.c:
	(serve_clnt_edit_run) the old function is renamed to the function
	  `do_serve_clnt_edit_run' and generalized to accept `cmd',
	  `run_size', `run_src', `ip' parameters;
	(serve_clnt_edit_run) the new function is just a wrapper around
	  `do_serve_clnt_edit_run';
	(serve_clnt_new_run) a new function to pass to the server
	  `SRV_CMD_NEW_RUN' command.

	* view.c:
	(serve_clnt_view) SRV_CMD_NEW_RUN_FORM is added to the list of
	  the allowed commands.

2004-06-19  Alexander Chernov  <cher@ispras.ru>

	* do_pass_fd.c, list_runs.c, open.c, pass_fd.c, recv_packet.c, send_packet.c, userlist_cmd.c:
	The `koi8-r' charset specification is removed from the file header.
	The copyright notice is updated.
	The compilation `compile-command' is updated.
	The `Cyrillic-KOI8' language environment setting is removed.

	* get_archive.c, message.c, show_item.c, simple_cmd.c, submit_clar.c:
	The `koi8-r' charset specification is removed from the file headers.
	The compilation `compile-command' is updated;
	The `Cyrillic-KOI8' language environment setting is removed.

	* edit_run.c, rejudge_by_mask.c, reset_filter.c, submit_run.c, upload_report.c:
	The `koi8-r' charset specification is removed from the file headers;
	The compilation `compile-command' is updated.

	* import_xml_runs.c, master_page.c, standings.c, team_page.c, view.c:
	The `koi8-r' charset specification is removed from the file headers.

2004-05-04  Alexander Chernov  <cher@ispras.ru>

	* view.c:
	(serve_clnt_view) a GNU C 3.3 warning about breaking strict aliasing
	  rules in -Wall -O2 mode is fixed.

	* upload_report.c:
	(serve_clnt_upload_report) a GNU C 3.3 warning about breaking strict
	  aliasing rules in -Wall -O2 mode is fixed.

	* submit_run.c:
	(serve_clnt_submit_run) a GNU C 3.3 warning about breaking strict
	  aliasing rules in -Wall -O2 mode is fixed.

	* reset_filter.c:
	(serve_clnt_reset_filter) a GNU C 3.3 warning about breaking strict
	  aliasing rules in -Wall -O2 mode is fixed.

	* rejudge_by_mask.c:
	(serve_clnt_rejudge_by_mask) a GNU C 3.3 warning about breaking strict
	  aliasing rules in -Wall -O2 mode is fixed.

	* master_page.c:
	(serve_clnt_master_page) a GNU C 3.3 warning about breaking strict
	  aliasing rules in -Wall -O2 mode is fixed.

	* edit_run.c:
	(serve_clnt_edit_run) a GNU C 3.3 warning about breaking strict
	  aliasing rules in -Wall -O2 mode is fixed.

	* team_page.c: copyright notice is updated;
	(serve_clnt_team_page) a GNU C 3.3 warning about breaking strict
	  aliasing rules in -Wall -O2 mode is fixed.

	* submit_clar.c: copyright notice is updated;
	(serve_clnt_submit_clar) a GNU C 3.3 warning about breaking strict
	  aliasing rules in -Wall -O2 mode is fixed.

	* standings.c: copyright notice is updated;
	(serve_clnt_standings) a GNU C 3.3 warning about breaking strict
	  aliasing rules in -Wall -O2 mode is fixed.

	* simple_cmd.c: copyright notice is updated;
	(serve_clnt_simple_cmd) a GNU C 3.3 warning about breaking strict
	  aliasing rules in -Wall -O2 mode is fixed.

	* show_item.c: copyright notice is updated;
	(serve_clnt_show_item) a GNU C 3.3 warning about breaking strict
	  aliasing rules in -Wall -O2 mode is fixed.

	* message.c: copyright notice is updated;
	(serve_clnt_message) a GNU C 3.3 warning about breaking strict
	  aliasing rules in -Wall -O2 mode is fixed.

	* import_xml_runs.c: copyright notice is updated;
	(serve_clnt_import_xml_runs) a GNU C 3.3 warning about breaking strict
	  aliasing rules in -Wall -O2 mode is fixed.

	* get_archive.c: copyright notice is updated;
	(serve_clnt_get_archive) a GNU C 3.3 warning about breaking strict
	  aliasing rules in -Wall -O2 mode is fixed.

2004-04-19  Alexander Chernov  <cher@ispras.ru>

	* rejudge_by_mask.c: initial revision

2004-04-17  Alexander Chernov  <cher@ispras.ru>

	* master_page.c: copyright notice is updated;
	(serve_clnt_master_page) new parameter `session_id' is added to pass
	  the session id.

	* reset_filter.c: initial revision

2004-03-31  Alexander Chernov  <cher@ispras.ru>

	* view.c:
	(serve_clnt_view) parameter `flags' is added, which contains command
	  flags to be passed to the server.

2004-03-30  Alexander Chernov  <cher@ispras.ru>

	* upload_report.c: initial revision

2004-03-26  Alexander Chernov  <cher@ispras.ru>

	* submit_run.c: copyright notice is updated;
	(serve_clnt_submit_run) added new parameter `run_size' to explicitly
	  pass the length of the source. This parameter is used to calculate
	  the overall packet size instead of taking the length of the string.
	  Thus, arbitrary binary data may be passed to the server.

	* view.c: copyright notice is updated;
	(serve_clnt_view) parameter `item2' is added. This parameter is then
	  passed to the server;
	  `PRIV_DOWNLOAD_RUN', `COMPARE_RUNS' commands are supported.

2004-02-16  Alexander Chernov  <cher@ispras.ru>

	* edit_run.c:
	(serve_clnt_edit_run) new parameter `pages' is added to pass to the
	  server.

2003-12-21  Alexander Chernov  <cher@ispras.ru>

	* edit_run.c:
	(serve_clnt_edit_run) new parameter `is_readonly' is added. This
	  parameter is passed to the server.

2003-12-14  Alexander Chernov  <cher@ispras.ru>

	* edit_run.c:
	(serve_clnt_edit_run) two new parameters added: `tests', `score' to
	  allow editing of the corresponding runlog entry fields.

2003-12-04  Alexander Chernov  <cher@ispras.ru>

	* edit_run.c:
	(serve_clnt_edit_run) new parameter `is_hidden' is added to edit
	  the `hidden' flag of the run.

2003-12-03  Alexander Chernov  <cher@ispras.ru>

	* edit_run.c:
	(serve_clnt_edit_run) new parameter `variant' is added, which is
	  the new variant number. To set the variant number, also
	  the corresponding bit in `mask' parameter must be set.

	* submit_run.c: copyright notice is updated;
	(serve_clnt_submit_run) function accepts two new parameters:
	  `cmd' - command to send to the server, either SRV_CMD_SUBMIT_RUN,
	          or SRV_CMD_PRIV_SUBMIT_RUN;
	  `variant' - the requested variant for the problem. Allowed only for
	              SRV_CMD_PRIV_SUBMIT_RUN command.

2003-10-31  Alexander Chernov  <cher@ispras.ru>

	* view.c:
	(serve_clnt_view) new request `SRV_CMD_WRITE_XML_RUNS' is handled.

2003-10-20  Alexander Chernov  <cher@ispras.ru>

	* edit_run.c: copyright notice is updated;
	(serve_clnt_edit_run) new: parameter `is_imported' added which is
	  then passed to the server.

	* view.c:
	(serve_clnt_view) new: `SRV_CMD_EXPORT_XML_RUNS' command is accepted.

	* import_xml_runs.c: Initial revision

2003-06-25  Alexander Chernov  <cher@ispras.ru>

	* master_page.c: copyright notice is updated;
	(serve_clnt_master_page) a new parameter 'extra_args' is added and
	  passed to the server. This parameter contains extra arguments, which
	  should be added to the self-referencing URL. Currently the
	  contest identifier is passed this way.

	* standings.c:
	(serve_clnt_standings) a new parameter 'extra_args' is added and passed
	  to the server. This parameter contains extra arguments, which
	  should be added to the self-referencing URL. Currently the
	  contest identifier is passed this way.

	* team_page.c: copyright notice is updated;
	(serve_clnt_team_page) a new parameter 'extra_args' is added and passed
	  to the server. This parameter contains extra arguments, which
	  should be added to the self-referencing URL. Currently the
	  contest identifier is passed this way.

	* view.c:
	(serve_clnt_view) a new parameter 'extra_args' is added and passed
	  to the server. This parameter contains extra arguments, which
	  should be added to the self-referencing URL. Currently the
	  contest identifier is passed this way.

2003-01-31  Alexander Chernov  <cher@ispras.ru>

	* view.c:
	(serve_clnt_view) DUMP_RUNS and DUMP_STANDINGS commands are accepted.

	* userlist_cmd.c: this is new name for `gen_passwords.c';
	copyright notice is updated;
	(serve_clnt_userlist_cmd) renamed from `serve_clnt_gen_passwords';
	  now accept parameter `cmd', which may be either GEN_PASSWORDS
	  or DUMP_USERS;
	  other minor changes due to renaming.

2003-01-06  Alexander Chernov  <cher@ispras.ru>

	* view.c: copyright notice is updated;
	(serve_clnt_view) severe indexing bug is fixed.

	* standings.c: copyright notice is updated;
	(serve_clnt_standings) severe indexing bug is fixed.

2002-12-27  Alexander Chernov  <cher@ispras.ru>

	* show_item.c:
	(serve_clnt_show_item) `SRV_CMD_VIRTUAL_STANDINGS' command is
	  enabled.

2002-12-21  Alexander Chernov  <cher@ispras.ru>

	* view.c:
	(serve_clnt_view) `SRV_CMD_VIEW_USERS' added as a valid request.

	* team_page.c:
	(serve_clnt_team_page) parameters are changed: `user_id',
	  `contest_id', `ip' are removed, since this information is taken
	  from userlist-server;
	  `simple_form', `multi_form' are removed, since session support
	  is done in different way;
	  `sid_mode', `self_url', `hidden_vars' are added to support
	  sessions.

	* master_page.c:
	(serve_clnt_master_page) new parameter `sid_mode' to pass session
	  support mode to the server.

	* standings.c: CVS identification fixed.

	* edit_run.c: Initial revision

2002-12-20  Alexander Chernov  <cher@ispras.ru>

	* simple_cmd.c, message.c, gen_passwords.c, standings.c, view.c:
	Initial revision

2002-12-14  Alexander Chernov  <cher@ispras.ru>

	* master_page.c:
	(serve_clnt_master_page) `flags' parameter is renamed to `priv_level'.

2002-12-13  Alexander Chernov  <cher@ispras.ru>

	* master_page.c:
	(serve_clnt_master_page) a new parameter `hidden_vars' added, which
	  is used to pass the hidden variables to be inserted into the
	  forms.

2002-12-12  Alexander Chernov  <cher@ispras.ru>

	* master_page.c: Initial revision

2002-12-01  Alexander Chernov  <cher@ispras.ru>

	* submit_clar.c:
	(serve_clnt_submit_clar) the client IP address is added to the
	  packet.

2002-11-29  Alexander Chernov  <cher@ispras.ru>

	* team_page.c: Initial revision

2002-11-25  Alexander Chernov  <cher@ispras.ru>

	* submit_run.c, submit_clar.c: Initial revision

2002-11-24  Alexander Chernov  <cher@ispras.ru>

	* show_item.c, send_packet.c, recv_packet.c, pass_fd.c, open.c, list_runs.c, get_archive.c, do_pass_fd.c:
	Initial revision

